﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 테스트 컨트롤
    /// </summary>
    public partial class TestControl : UserControl
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TestControl()

        /// <summary>
        /// 생성자
        /// </summary>
        public TestControl()
        {
            InitializeComponent();

            #region 이벤트를 설정한다.

            Load   += UserControl_Load;
            Resize += UserControl_Resize;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public
        //////////////////////////////////////////////////////////////////////////////// Function

        #region 안녕하세요 - SayHello()

        /// <summary>
        /// 안녕하세요
        /// </summary>
        public void SayHello()
        {
            MessageBox.Show(this, "안녕하세요!", "테스트 컨트롤", MessageBoxButtons.OK);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 사용자 컨트롤 로드시 처리하기 - UserControl_Load(sender, e)

        /// <summary>
        /// 사용자 컨트롤 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void UserControl_Load(object sender, EventArgs e)
        {
            if(!DesignMode)
            {
                Visible = false;
            }
        }

        #endregion
        #region 사용자 컨트롤 크기 조정시 처리하기 - UserControl_Resize(sender, e)

        /// <summary>
        /// 사용자 컨트롤 크기 조정시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void UserControl_Resize(object sender, EventArgs e)
        {
            Size = BackgroundImage.Size;
        }

        #endregion
    }
}